package org.gjt.abies;

public class StringUtil {

    public static String replace(String src, String oldPattern,
            String newPattern) {

        StringBuffer dst = new StringBuffer(); // the new bult up string based on src
        int i; // index of found token
        int last = 0; // last valid non token string data for concat
        boolean done = false; // determines if we're done.

        // while we'er not done, try finding and replacing
        while (!done) {
            // search for the pattern...
            i = src.indexOf(oldPattern, last);
            // if it's not found from our last point in the src string....
            if (i == -1) {
                // we're done.
                done = true;
                // if our last point, happens to be before the end of the string
                if (last < src.length()) {
                    // concat the rest of the string to our dst string
                    dst.append(src.substring(last, (src.length())));
                }
            } else {
                // we found the pattern
                if (i != last) {
                    // if the pattern's not at the very first char of our
                    // searching point....
                    // we need to concat the text up to that point..
                    dst.append(src.substring(last, i));
                }
                // update our last var to our current found pattern, plus the
                // lenght of the pattern
                last = i + oldPattern.length();
                // concat the new pattern to the dst string
                dst.append(newPattern);
            }
        }
        // finally, return the new string
        return dst.toString();
    }

}