
package org.gjt.abies.dialog;

import java.io.*;

import org.gjt.abies.StringUtil;
import org.gjt.abies.nanogroovy.*;


public class DialogParser {
	
	public Dialog dialog;
	
	/**
	 * @param stream
	 */
	public void parseDialog(Reader input) throws IOException {
		XMLElement xml = new XMLElement(true);
		xml.parseFromReader(input);
		dialog = new Dialog();
		dialog.parse(xml);
		
	}
	
	public String quoteJavaString(String str) {
		str = StringUtil.replace(str,"\n","\\n");
		str = StringUtil.replace(str,"\r","\\r");
		str = StringUtil.replace(str,"\"","\\\"");
		str = StringUtil.replace(str,"\t","\\t");
		return "\""+str+"\"";
	}
	
	public static void main(String[] args) throws IOException {
		
	}
	

}
